---
title: IDBObjectStoreSync
slug: Web/API/IDBObjectStoreSync
tags:
  - API
  - IndexedDB
  - Interface
  - Obsolete
  - Reference
---
<p>{{ APIRef("IndexedDB") }}</p>

<div class="warning">
<p><strong>Important</strong>: The synchronous version of the IndexedDB API was originally intended for use only with <a href="/en-US/docs/Web/Guide/Performance/Using_web_workers">Web Workers</a>, and was eventually removed from the spec because its need was questionable. It may however be reintroduced in the future if there is enough demand from web developers.</p>
</div>

<p>The <code>IDBObjectStoreSync</code> interface of the <a href="/en/IndexedDB" title="en/IndexedDB">IndexedDB API</a> provides synchronous access to an <a href="/en/IndexedDB#gloss_object_store" title="en/IndexedDB#gloss object store">object store</a> of a database.</p>

<h2 id="Method_overview">Method overview</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <td><code>any <a href="#add">add</a> (in any value, in optional any key) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>);</code></td>
  </tr>
  <tr>
   <td><a href="/en/IndexedDB/IDBIndexSync" title="en/IndexedDB/IDBIndexSync"><span style="font-family: monospace;">IDBIndexSync</span></a><code> <a href="#createIndex">createIndex</a> (in DOMString name, in DOMString storeName, in DOMString keypath, in optional boolean unique);</code></td>
  </tr>
  <tr>
   <td><code>any <a href="#get">get</a> (in any key) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>); </code></td>
  </tr>
  <tr>
   <td><code><a href="/en/IndexedDB/IDBCursorSync" title="en/IndexedDB/IDBCursorSync">IDBCursorSync</a> <a href="#openCursor">openCursor</a> (in optional <a href="/en/IndexedDB/IDBKeyRange" title="en/IndexedDB/IDBKeyRange">IDBKeyRange</a> range, in optional unsigned short direction) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>);</code></td>
  </tr>
  <tr>
   <td><code><a href="/en/IndexedDB/IDBIndexSync" title="en/IndexedDB/IDBIndexSync">IDBIndexSync</a> <a href="#openIndex">openIndex</a> (in DOMString name) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>); </code></td>
  </tr>
  <tr>
   <td><code>any <a href="#put">put</a> (in any value, in optional any key) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>); </code></td>
  </tr>
  <tr>
   <td><code>void <a href="#remove">remove</a> (in any key) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>);</code></td>
  </tr>
  <tr>
   <td><code>void <a href="#removeIndex">removeIndex</a> (in DOMString indexName) raises (<a href="/en/IndexedDB/IDBDatabaseException" title="en/IndexedDB/IDBDatabaseException">IDBDatabaseException</a>);</code></td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Type</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code><a name="attr_indexNames">indexNames</a></code></td>
   <td><code>readonly DOMStringList</code></td>
   <td>A list of the names of the <a href="/en/IndexedDB#gloss_index" title="en/IndexedDB#gloss index">indexes</a> on this object store.</td>
  </tr>
  <tr>
   <td><code><a name="attr_keyPath">keyPath</a></code></td>
   <td><code>readonly DOMString</code></td>
   <td>The <a href="/en/IndexedDB#gloss_key_path" title="en/IndexedDB#gloss key path">key path</a> of this object store. If this attribute is set to null, then the application must provide a key for each modification operation.</td>
  </tr>
  <tr>
   <td><code><a name="attr_mode">mode</a></code></td>
   <td><code>readonly unsigned short</code></td>
   <td>The mode for isolating access to the data in this object store. For possible values, see <a href="/en/indexeddb/idbobjectstoresync#Constants">Constants</a>.</td>
  </tr>
  <tr>
   <td><code><a name="attr_name">name</a></code></td>
   <td><code>readonly DOMString</code></td>
   <td>The name of this object store.</td>
  </tr>
 </tbody>
</table>

<h2 id="Constants"> Constants</h2>

<h3 id="Mode_constants">Mode constants</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Constant</th>
   <th scope="col">Value</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code><a name="const_read_only">READ_ONLY</a></code></td>
   <td>1</td>
   <td>Modification operations are not allowed on this object store.</td>
  </tr>
  <tr>
   <td><code><a name="const_read_write">READ_WRITE</a></code></td>
   <td>0</td>
   <td>Modification operations are allowed on this object store.</td>
  </tr>
  <tr>
   <td><code><a name="const_snapshot_read">SNAPSHOT_READ</a></code></td>
   <td>2</td>
   <td>Any read operations must access a snapshot view of the data, which cannot change once it is created.</td>
  </tr>
 </tbody>
</table>

<h2 id="Methods">Methods</h2>

<h3 id="add()">add()</h3>

<p>Stores the given value into this object store, optionally with the specified key. If a record already exists with the given key, an exception is raised.</p>

<pre>any add(
  in any value,
  in optional any key
) raises (IDBDatabaseException);
</pre>

<h5 id="Parameters">Parameters</h5>

<h5 id="Returns">Returns</h5>

<h5 id="Exceptions">Exceptions</h5>

<p>This method can raise a IDBDatabaseException with the following codes:</p>

<dl>
 <dt>value</dt>
 <dd>The value to store into the index.</dd>
 <dt>key</dt>
 <dd>A key to use for identifying the record.</dd>
 <dt><code>any</code></dt>
 <dd>The key for the stored record.</dd>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#CONSTRAINT_ERR" title="en/IndexedDB/DatabaseException#CONSTRAINT ERR">CONSTRAINT_ERR</a></code></dt>
 <dd>If a record exists in this index with a key corresponding to the <em>key</em> parameter or the index is auto-populated, or if no record exists with a key corresponding to the <em>value</em> parameter in the index's referenced object store.</dd>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#DATA_ERR" title="en/IndexedDB/DatabaseException#DATA ERR">DATA_ERR</a></code></dt>
 <dd>If this object store uses <a href="/en/IndexedDB#gloss_out-of-line_key" title="en/IndexedDB#gloss out-of-line key">out-of-line keys</a>, and the <em>key</em> parameter was not passed.</dd>
 <dt><code><code><a href="/en/IndexedDB/IDBDatabaseException#SERIAL_ERR" title="en/IndexedDB/DatabaseException#SERIAL ERR">SERIAL_ERR</a></code></code></dt>
 <dd>If the data being stored could not be serialized by the internal structured cloning algorithm.</dd>
</dl>

<h3 id="createIndex">createIndex()</h3>

<p>Creates and returns a new index with the given name in the connected database.</p>

<pre class="eval"> IDBIndexSync createIndex (
    in DOMString name,
    in DOMString keypath,
    in optional boolean unique
 );
</pre>

<h5 id="Parameters_2">Parameters</h5>

<dl>
 <dt>name</dt>
 <dd>The name of a new index.</dd>
 <dt>keyPath</dt>
 <dd>The key path used by the new index.</dd>
 <dt>unique</dt>
 <dd>If true, keys in the index must be unique; if false, duplicate keys are allowed.</dd>
</dl>

<h5 id="Returns_2">Returns</h5>

<dl>
 <dt><a href="/en/IndexedDB/IDBIndexSync" title="en/IndexedDB/IDBIndexSync"><code>IDBIndexSync</code></a></dt>
 <dd>An object to access the newly created index.</dd>
</dl>

<h3 id="get()">get()</h3>

<p>Retrieves and returns the value from this object store for the record that corresponds to the given key.</p>

<pre>any get (
  in any key
) raises (IDBDatabaseException);
</pre>

<h5 id="Parameters_3">Parameters</h5>

<dl>
 <dt>key</dt>
 <dd>The key that identifies the record to be retrieved.</dd>
</dl>

<h5 id="Returns_3">Returns</h5>

<dl>
 <dt><code>any</code></dt>
 <dd>The value retrieved from the object store.</dd>
</dl>

<h5 id="Exceptions_2">Exceptions</h5>

<p>This method can raise a IDBDatabaseException with the following codes:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#SERIAL_ERR" title="en/IndexedDB/DatabaseException#SERIAL ERR">SERIAL_ERR</a></code></dt>
 <dd>If the data being stored could not be deserialized by the internal structured cloning algorithm.</dd>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#NOT_FOUND_ERR" title="en/IndexedDB/DatabaseException#NOT FOUND ERR">NOT_FOUND_ERR</a></code></dt>
 <dd>If no record exists in this index for the given key.</dd>
</dl>

<h3 id="openCursor()">openCursor()</h3>

<p>Creates a <a href="/en/IndexedDB#gloss_cursor" title="en/IndexedDB#gloss cursor">cursor</a> over the records of this object store. The range of the new cursor matches the specified <a href="/en/IndexedDB#gloss_key_range" title="en/IndexedDB#gloss key range">key range</a>; if the key range is not specified or is null, then the range includes all the records.</p>

<pre>CursorSync openCursor (
  in optional KeyRange range,
  in optional unsigned short direction
) raises (DatabaseException);
</pre>

<h5 id="Parameters_4">Parameters</h5>

<dl>
 <dt>range</dt>
 <dd>The key range to use as the cursor's range.</dd>
 <dt>direction</dt>
 <dd>The cursor's required direction.</dd>
</dl>

<h5 id="Returns_4">Returns</h5>

<dl>
 <dt><code>IDBIndexSync</code></dt>
 <dd>An object for accessing the index.</dd>
</dl>

<h5 id="Exceptions_3">Exceptions</h5>

<p>This method can raise a DatabaseException with the following code:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#NOT_FOUND_ERR" title="en/IndexedDB/DatabaseException#NOT FOUND ERR">NOT_FOUND_ERR</a></code></dt>
 <dd>If no records exist in this index for the requested key range.</dd>
</dl>

<h3 id="openIndex">openIndex()</h3>

<p>Opens the index with the given name, using the mode of the current transaction.</p>

<pre class="eval"> IDBIndexSync openIndex (
   in DOMString name
 ) raises  (IDBDatabaseException);
</pre>

<h5 id="Parameters_5">Parameters</h5>

<dl>
 <dt>name</dt>
 <dd>The name of the index to open.</dd>
</dl>

<h5 id="Returns_5">Returns</h5>

<dl>
 <dt><a href="/en/IndexedDB/IDBIndexSync" title="en/IndexedDB/IDBIndexSync"><code>IDBIndexSync</code></a></dt>
 <dd>An object to access the index.</dd>
</dl>

<h5 id="Exceptions_4">Exceptions</h5>

<p>This method can raise an IDBDatabaseException with the following code:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#NOT_FOUND_ERR" title="en/IndexedDB/DatabaseException#NOT FOUND ERR">NOT_FOUND_ERR</a></code></dt>
 <dd>If the index with the given name does not exist in the connected database.</dd>
</dl>

<h3 id="put()">put()</h3>

<p>Stores the given value in this object store and returns the key for the stored record. If a record already exists with the given key, it is overwritten.</p>

<pre>any put (
  in any value,
  in optional any key
) raises (IDBDatabaseException);
</pre>

<h5 id="Parameters_6">Parameters</h5>

<dl>
 <dt>value</dt>
 <dd>The value to be stored in the record.</dd>
 <dt>key</dt>
 <dd>The key to be used to identify the record.</dd>
</dl>

<h5 id="Returns_6">Returns</h5>

<dl>
 <dt><code>any</code></dt>
 <dd>The key for the stored record.</dd>
</dl>

<h5 id="Exceptions_5">Exceptions</h5>

<p>This method can raise an IDBDatabaseException with the following codes:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#CONSTRAINT_ERR" title="en/IndexedDB/DatabaseException#CONSTRAINT ERR">CONSTRAINT_ERR</a></code></dt>
 <dd>If noOverwrite was true, and a record exists in this index for the given key or this index is auto-populated; or if no record exists with the given key in the index's referenced object store.</dd>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#DATA_ERR" title="en/IndexedDB/DatabaseException#DATA ERR">DATA_ERR</a></code></dt>
 <dd>If this object store uses <a href="/en/IndexedDB#gloss_out-of-line_key" title="en/IndexedDB#gloss out-of-line key">out-of-line</a> keys and no <a href="/en/IndexedDB#gloss_key_generator" title="en/IndexedDB#gloss key generator">key generator</a>, but no key was given.</dd>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#SERIAL_ERR" title="en/IndexedDB/DatabaseException#SERIAL ERR">SERIAL_ERR</a></code></dt>
 <dd>If the data being stored could not be serialized by the internal structured cloning algorithm.</dd>
</dl>

<h3 id="remove">remove()</h3>

<p>Removes from this object store any records that correspond to the given key.</p>

<pre>void remove (
  in any key
) raises (IDBDatabaseException);
</pre>

<h5 id="Parameters_7">Parameters</h5>

<dl>
 <dt>key</dt>
 <dd>Key of the records to be removed.</dd>
</dl>

<h5 id="Returns_7">Returns</h5>

<p><code>void</code></p>

<h5 id="Exceptions_6">Exceptions</h5>

<p>This method can raise a IDBDatabaseException with the following code:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#NOT_FOUND_ERR" title="en/IndexedDB/DatabaseException#NOT FOUND ERR">NOT_FOUND_ERR</a></code></dt>
 <dd>If a record does not exist in this index with the given key.</dd>
</dl>

<h3 id="removeIndex">removeIndex()</h3>

<p>Destroys an index with the given name.</p>

<pre>  void removeIndex (
    in DOMString indexName
  ) raises (IDBDatabaseException);
</pre>

<h5 id="Parameters_8">Parameters</h5>

<dl>
 <dt>indexName</dt>
 <dd>The name of the existing index to remove.</dd>
</dl>

<h5 id="Exceptions_7">Exceptions</h5>

<p>This method can raise an IDBDatabaseException with the following code:</p>

<dl>
 <dt><code><a href="/en/IndexedDB/IDBDatabaseException#NOT_FOUND_ERR" title="en/IndexedDB/DatabaseException#NOT FOUND ERR">NOT_FOUND_ERR</a></code></dt>
 <dd>If an index with the given name does not exist in the connected database.</dd>
</dl>
